<template>
  <v-row justify="center">
    <v-dialog v-model="dialog" persistent max-width="600px">
        <v-card>
            <v-card-title>
            <span class="text-h5">Yours Playlists</span>
            </v-card-title>

            <v-card-text>
                <v-container>
                    <v-form @submit.prevent="save">
                        <v-row>
                            <v-col cols="12" sm="3" md="6">
                                <v-text-field v-model="name" label="Name"/>
                            </v-col>
                            <v-col cols="12" sm="3" md="6">
                                <v-btn color="priamry" type="submit"><v-icon>mdi-content-save-outline</v-icon></v-btn>
                            </v-col>
                        </v-row>
                    </v-form>

                    <v-simple-table>
                        <template v-slot:default>
                            <thead>
                                <tr>
                                    <th class="text-left">Name</th>
                                    <th class="text-left"></th>
                                    <th class="text-right">
                                        <v-btn dark small @click="onPageChange"><v-icon>mdi-reload</v-icon></v-btn>
                                    </th>
                                </tr>
                            </thead>

                            <tbody>
                                <tr v-for="(play, i) in playlists" :key="i">
                                    <td>{{ play.name }}</td>
                                    <td>{{ play.videos.length }}</td>
                                    <td>
                                        <v-btn color="success" small @click="edit(play.id)"><v-icon>mdi-square-edit-outline</v-icon></v-btn>
                                        <v-btn color="error" small v-if="!play.videos.length" @click="deletePlaylist(play.id)"><v-icon>mdi-close-circle-outline</v-icon></v-btn>
                                    </td>
                                </tr>
                            </tbody>
                        </template>
                    </v-simple-table>

                    <v-pagination
                        v-model="pagination.current"
                        :length="pagination.total"
                        total-visible="5"
                        @input="onPageChange"
                    ></v-pagination>

                    <alert v-if="alert.showAlert" :show="alert.showAlert" :text="alert.msg" :type="alert.type" v-on:snackbar="alert.showAlert = false"/>
                </v-container>
            </v-card-text>

            <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue darken-1" text @click="$emit('windowPlaylist')">
                    Close
                </v-btn>
            </v-card-actions>
        </v-card>
    </v-dialog>
  </v-row>
</template>

<script>
export default {
  name: 'PlayListForm',
  data () {
    return {
      id: '',
      name: '',
      playlists: [],
      dialog: false,
      alert: {
        showAlert: false,
        msg: '',
        type: ''
      },
      pagination: {
        current: 1,
        total: 0
      }
    }
  },
  props: {
    show: Boolean
  },
  created () {
    this.dialog = this.show
    this.getPlayLists()
  },
  methods: {
    async edit (id) {
      this.id = id
      await this.$axios.get(`playlists/${id}`).then((r) => {
        if (r.data) {
          this.name = r.data.name
        }
      }).catch((e) => {

      })
    },
    async getPlayLists () {
      this.playlists = []
      await this.$axios.get(`playlists?page=${this.pagination.current}`).then((r) => {
        if (r.data) {
          this.playlists = r.data.data
          this.pagination.total = r.data.last_page
          this.pagination.current = r.data.current_page
        }
      }).catch((e) => {

      })
    },
    save () {
      if (this.id) {
        this.update()
      } else {
        this.create()
      }
    },
    async update () {
      await this.$axios.put(`playlists/${this.id}`, {
        name: this.name
      }).then((r) => {
        if (r.data.status) {
          this.alertError(r.data.msg)
          this.getPlayLists()
          this.id = ''
          this.$emit('getPlaylists')
        }
      }).catch((e) => {
        // this.alertError()
      })
    },
    async create () {
      await this.$axios.post('playlists', {
        name: this.name
      }).then((r) => {
        if (r.data.status) {
          this.alertError(r.data.msg)
          this.getPlayLists()
          this.$emit('getPlaylists')
        }
      }).catch((e) => {
        // this.alertError()
      })
    },
    async deletePlaylist (id) {
      const confirmation = confirm('Deseja realmente excluir esta playlist?')
      if (confirmation) {
        await this.$axios.delete(`playlists/${id}`).then((r) => {
          if (r.data.status) {
            this.alertError(r.data.msg)
            this.getPlayLists()
          }
        })
      }
    },
    onPageChange () {
      this.getPlayLists()
    },
    alertError (erro = null, type = 'success') {
      if (this.alert.showAlert) {
        this.alert.showAlert = false
      }
      this.alert.showAlert = true
      this.alert.msg = erro
      this.alert.type = type
    }
  }
}
</script>

<style>

</style>
